<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

// $json = [
//     'id_user' => '37e44344-f0c5-11ec-a869-00e04c0362fc',
//     'id_unit' => '07678cc9-f15b-11ec-a0db-00e04c0362fc',
//     'id_section' => 'f0b74a11-f221-11ec-9768-00e04c0362fc',
//     'id_content' => 'caba25ad-f233-11ec-9768-00e04c0362fc'
// ];

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);


if(empty($json['id_content'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_content'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_content = mysqli_real_escape_string($conn,$json['id_content']);

// TEST USER PERMITION

    $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

//

// GET CONTENT
    $sql_content = "SELECT 
        c.id_content,
        c.type,
        c.order,
        c.title,
        c.meta,
        c.status,
        c.id_section
        FROM contents c
        WHERE (c.id_content = '{$id_content}')
    ";

    $result_content = mysqli_query($conn,$sql_content);

    if(mysqli_num_rows($result_content) < 1){
        http_response_code(403);
        die();
    }

    $row_content = mysqli_fetch_assoc($result_content);

    $content_order = $row_content['order'];
    $id_section = $row_content['id_section'];
    $new_content_order = array();

    if($content_order > 0){
        $sql_contents = "SELECT id_content, title FROM contents WHERE id_section = '{$id_section}' AND `order` > 0 ORDER BY `order` ASC";
        $result_contents = mysqli_query($conn,$sql_contents);
        if(!$result_contents){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'select_units'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }

        $counter = 0;
    
        while($row_list_contents = mysqli_fetch_assoc($result_contents)){
            $counter++;
            $new_content_order[] = [
                'id_content' => $row_list_contents['id_content'],
                'label'   => $row_list_contents['title'],
                'order'   => $counter
            ];
        }
    }else{
        $new_content_order[] = [
            'id_content' => $row_content['id_content'],
            'label'   => $row_content['title'],
            'order'   => $row_content['order']
        ];
    }


    $meta = json_decode($row_content['meta'], true);
    $json_content['content_data'] = [
        'id_content'    => $row_content['id_content'],
        'id_section'    => $row_content['id_section'],
        'type'          => $row_content['type'],
        'title'         => $row_content['title'],
        'active'        => $row_content['status'] == 1 ? true : false,
        'order'         => $row_content['order'],
        'meta'          => $meta,
        'order_options' => $new_content_order
    ];
// END GET CONTENT


http_response_code(200);
die(json_encode($json_content,JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
?>

