<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_level'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_level'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_level = mysqli_real_escape_string($conn,$json['id_level']);

$sql_levels = "SELECT l.id_level, 
    l.label, 
    l.order, 
    l.class_name, 
    l.icon, 
    l.status
    FROM levels l WHERE l.id_level = '{$id_level}'";

$result_levels = mysqli_query($conn,$sql_levels);

if(!$result_levels){
    $error = mysqli_error($conn);
    mysqli_close($conn);
    http_response_code(500);
    die(json_encode([
        'debug' => 'erro na query, ' . $error
    ],JSON_UNESCAPED_UNICODE));
}

$json_levels = [];

$row_level = mysqli_fetch_assoc($result_levels);

//DEFINE DADOS DO LEVEL
$id_level = $row_level['id_level'];
$label_level = $row_level['label'];
$order_level = $row_level['order'];
$class_level = $row_level['class_name'];
$icon_level = $row_level['icon'];

http_response_code(200);
die(json_encode([
    'level_data' => [
        'label' => $label_level,
        'color' => $class_level,
        'order' => $order_level,
        'icon' => $icon_level
    ]
],JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));

?>