<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_level'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_level'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_level = mysqli_real_escape_string($conn,$json['id_level']);

// TEST USER PERMITION
        $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

//check if it can be deleted
$sql_check = "SELECT l.id_level
FROM levels l 
INNER JOIN units u USING(id_level)
INNER JOIN sections s USING(id_unit)
INNER JOIN contents c USING(id_section)
INNER JOIN answers a USING(id_content)
WHERE l.id_level = '{$id_level}';";

$result_check = mysqli_query($conn,$sql_check);

if(!$result_check){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(mysqli_num_rows($result_check) > 0){
    http_response_code(400);
    die(json_encode([
        'message' => 'Você não pode deletar um Level que já tenha registro de progresso de alunos'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

// QUERIES
$sql_delete_contents = "DELETE 
FROM contents 
WHERE id_section IN (
    SELECT s.id_section
    FROM sections s
    INNER JOIN units u USING(id_unit)
    WHERE u.id_level = '{$id_level}'
);";

$sql_delete_sections = "DELETE 
FROM sections 
WHERE id_unit IN (
    SELECT u.id_unit
    FROM units u
    WHERE u.id_level = '{$id_level}'
);";

$sql_delete_units = "DELETE FROM units 
WHERE id_level = '{$id_level}';";

$sql_delete_level = "DELETE FROM levels 
WHERE id_level = '{$id_level}';";

mysqli_begin_transaction($conn);

$result_delete_contents = mysqli_query($conn,$sql_delete_contents);
$result_delete_sections = mysqli_query($conn,$sql_delete_sections);
$result_delete_units = mysqli_query($conn,$sql_delete_units);
$result_delete_levels = mysqli_query($conn,$sql_delete_level);

if(!$result_delete_contents){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug2' => 'contents'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
if(!$result_delete_sections){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug2' => 'sections'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
if(!$result_delete_units){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug2' => 'units'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
if(!$result_delete_levels){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug2' => 'levels'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

