<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_level'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_level'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_level = mysqli_real_escape_string($conn,$json['id_level']);

if(empty($json['level_data'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'level_data'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$level_data = $json['level_data'];

if(isset($level_data['label'])){
    $label = mysqli_real_escape_string($conn,$level_data['label']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'label'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($level_data['color'])){
    $color = mysqli_real_escape_string($conn,$level_data['color']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'color'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($level_data['icon'])){
    $icon = mysqli_real_escape_string($conn,$level_data['icon']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'icon'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

// TEST USER PERMITION

    $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

$sql_create = "UPDATE levels SET label = '{$label}', class_name = '{$color}', icon = '{$icon}' WHERE id_level = '{$id_level}'";

$result_create = mysqli_query($conn,$sql_create);

if(!$result_create){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug_sql' => $sql_create
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

