<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

$id_user = mysqli_real_escape_string($conn, $json["id_user"]);

$test_permition = test_permition($conn,$id_user,3);

if(empty($json['id_user'])){
  http_response_code(400);
  die(json_encode([
    'debug' => 'id_user'
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if($test_permition['status'] != 200){
  mysqli_close($conn);
  http_response_code(500);
  die(json_encode([
      'debug' => $test_permition
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(!$test_permition['response']['permition']){
  mysqli_close($conn);
  http_response_code(403);
  die(json_encode([
      'debug' => 'permition'
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$label = mysqli_real_escape_string($conn, $json["data_links"]["label"]);
$link = mysqli_real_escape_string($conn, $json["data_links"]["link"]);
$id_link = mysqli_real_escape_string($conn, $json["data_links"]["id_link"]);
$ordem = mysqli_real_escape_string($conn, $json["data_links"]["ordem"]);

if(empty($label)) {
  http_response_code(400);
    die(json_encode([
        'debug' => 'label'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($id_link)) {
  http_response_code(400);
    die(json_encode([
        'debug' => 'label'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


if(empty($link)) {
  http_response_code(400);
    die(json_encode([
        'debug' => 'link'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($ordem)) {
  http_response_code(400);
    die(json_encode([
        'debug' => 'ordem'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$query_link = "UPDATE links
               SET label = '{$label}', link = '{$link}', ordem = '{$ordem}'
               WHERE id_link = '{$id_link}';
";

$result_link = mysqli_query($conn, $query_link);

if(!$result_link){
  $error = mysqli_error($conn);
  http_response_code(500);
  mysqli_rollback($conn);
  mysqli_close($conn);
  die(json_encode([
      'debug' => $error
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);


?>