<?php 

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);

$test_permition = test_permition($conn,$id_user,2);

if($test_permition['status'] != 200){
  mysqli_close($conn);
  http_response_code(500);
  die(json_encode([
    'debug' => $test_permition
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(!$test_permition['response']['permition']){
  mysqli_close($conn);
  http_response_code(403);
  die(json_encode([
    'debug' => 'permition'
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_link = mysqli_real_escape_string($conn,$json['id_link']);

if(empty($id_link)) {
  http_response_code(400);
    die(json_encode([
        'debug' => 'label'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$query_get_links = "SELECT 
                    l.label, 
                    l.link,
                    l.id_link,
                    l.ordem
                    FROM links l
                    WHERE l.id_link = '{$id_link}'
";

$result_get_links = mysqli_query($conn, $query_get_links);

$link = [];

$link['links'] = [];

if( mysqli_num_rows($result_get_links) == 0 ) {

  http_response_code(500);
  die(json_encode([
      'debug' => $sql_contents
  ],JSON_UNESCAPED_UNICODE));

}

$row = mysqli_fetch_assoc($result_get_links);
     
$link['link'] = [
  "link"    => $row['link'],
  "label"   => $row['label'],
  "ordem"   => $row['ordem'],
  "linkId"  => $row['id_link']
];


http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);
die(json_encode($link,JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>