<?php 

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);

$test_permition = test_permition($conn,$id_user,3);

if($test_permition['status'] != 200){
  mysqli_close($conn);
  http_response_code(500);
  die(json_encode([
      'debug' => $test_permition
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(!$test_permition['response']['permition']){
  mysqli_close($conn);
  http_response_code(403);
  die(json_encode([
      'debug' => 'permition'
  ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$media = mysqli_real_escape_string($conn,$json['media']);

if(empty($media)) {
  http_response_code(400);
    die(json_encode([
        'debug' => 'media'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$query_media_delete = "DELETE FROM current_average WHERE average > 0";

$result_media_delete = mysqli_query($conn, $query_media_delete);

$query_media_insert = "INSERT INTO current_average(average) VALUES({$media})";

$result_media_insert = mysqli_query($conn, $query_media_insert);

if(!$result_media_delete) {

  http_response_code(500);
  die(json_encode([
      'debug' => $query_media_delete
  ],JSON_UNESCAPED_UNICODE));

}

if(!$result_media_insert) {

  http_response_code(500);
  die(json_encode([
      'debug' => $query_media_insert
  ],JSON_UNESCAPED_UNICODE));

}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);
?>