<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../config/db-connection.php';
include_once __DIR__ . '/../config/https_environment.php';
include_once __DIR__ . '/../utils/utils.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);
$link = mysqli_real_escape_string($conn,$json['link']);

$path = '';

$unit_name = null;
if(isset($json['id_unit'])){
    $id_unit = mysqli_real_escape_string($conn,$json['id_unit']);

    $sql = "SELECT u.label,l.label as level_label FROM units u INNER JOIN levels l USING(id_level) WHERE u.id_unit = '{$id_unit}';";
    $result = mysqli_query($conn,$sql);
    if($result && mysqli_num_rows($result) > 0 ){
        $row = mysqli_fetch_assoc($result);
        $unit_name = $row['label'];
        $level_label = $row['level_label'];
        $path .= "{$level_label} > {$unit_name} ";

    }

}

$section_name = null;
if(isset($json['id_section'])){
    $id_section = mysqli_real_escape_string($conn,$json['id_section']);

    $sql = "SELECT label FROM sections WHERE id_section = '{$id_section}';";
    $result = mysqli_query($conn,$sql);
    if($result && mysqli_num_rows($result) > 0 ){
        $row = mysqli_fetch_assoc($result);
        $section_name = $row['label'];
        $path .= "> {$section_name} ";

    }

}

if(isset($json['id_content'])){
    $id_content = mysqli_real_escape_string($conn,$json['id_content']);


    $sql = "SELECT title FROM contents WHERE id_content = '{$id_content}';";
    $result = mysqli_query($conn,$sql);
    if($result && mysqli_num_rows($result) > 0 ){
        $row = mysqli_fetch_assoc($result);
        $content_name = $row['title'];
        $path .= "> {$content_name}";
    }

}

$description = $json['description'];

//EXECUTE EMAIL SEND
    send_bug_email($conn,$id_user,$link,$path,$description);

// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die();

?>