<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_unit'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_unit'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_unit = mysqli_real_escape_string($conn,$json['id_unit']);

$sql_unit = "SELECT id_unit,
    id_level,
    label, 
    `order`,
    optional
    FROM units WHERE id_unit = '{$id_unit}'";

$result_unit = mysqli_query($conn,$sql_unit);


if(!$result_unit){
    $error = mysqli_error($conn);
    mysqli_close($conn);
    http_response_code(500);
    die(json_encode([
        'debug' => 'erro na query, ' . $error
    ],JSON_UNESCAPED_UNICODE));
}


$row_unit = mysqli_fetch_assoc($result_unit);

//DEFINE DADOS DA UNIT
$id_level = $row_unit['id_level'];
$label = $row_unit['label'];
$order = $row_unit['order'];
$optional = $row_unit['optional'] == 1 ? true : false;

//SELECT ALL UNITS FROM THIS LEVEL EXCEPT THE CURRENT UNIT
    $sql_units = "SELECT id_unit, label FROM units WHERE id_level = '{$id_level}' ORDER BY `order` ASC";
    $result_units = mysqli_query($conn,$sql_units);
    if(!$result_units){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'select_units'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $order_units = array();
    $counter = 0;

    while($row_units = mysqli_fetch_assoc($result_units)){
        $counter++;
        $new_order_units[] = [
            'id_unit' => $row_units['id_unit'],
            'label'   => $row_units['label'],
            'order'   => $counter
        ];
    }
http_response_code(200);
die(json_encode([
    'unit_data' => [
        'label' => $label,
        'order' => $order,
        'order_options' => $new_order_units,
        'optional' => $optional
    ]
],JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));

?>