<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_unit'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_unit'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_unit = mysqli_real_escape_string($conn,$json['id_unit']);

// TEST USER PERMITION
        $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

// GET UNIT & LEVEL ORDER 
    $sql_orders = "SELECT l.order as level_order, l.id_level, u.order FROM levels l INNER JOIN units u USING(id_level) WHERE u.id_unit = '{$id_unit}'";
    $result_orders = mysqli_query($conn,$sql_orders);
    if(!$result_orders){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'orders'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $row_orders = mysqli_fetch_assoc($result_orders);
    $level_order = $row_orders['level_order'];
    $unit_order = $row_orders['order'];
    $id_level = $row_orders['id_level'];

// GET MAX ORDER
    $sql_order = "SELECT max(`order`) as max_order FROM units WHERE id_level = '{$id_level}'";

    $result_order = mysqli_query($conn,$sql_order);

    if(!$result_order){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $row_order = mysqli_fetch_assoc($result_order);
    $max_order = $row_order['max_order'];
// GET USERS FROM THIS LEVEL
    $sql_progress = "SELECT up.id_user,
        up.level_order,
        up.unit_order,
        up.section_order,
        up.content_order,
        up.units_progress,
        u.id_unit
    FROM user_progress up
    INNER JOIN levels l ON up.level_order = l.order 
    INNER JOIN units u ON l.id_level = u.id_level
    WHERE up.level_order = {$level_order}
    GROUP BY up.id_user";

    $result_progress = mysqli_query($conn,$sql_progress);
    if(!$result_progress){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'orders'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $all_users = array();
    $same_unit_users = array();
    $relocate_unit_users = array();

    while($row_progress = mysqli_fetch_assoc($result_progress)){

        $all_users[$row_progress['id_user']] = [
            'id_user' => $row_progress['id_user'],
            'level_order' => $row_progress['level_order'],
            'unit_order' => $row_progress['unit_order'],
            'id_unit' => $row_progress['id_unit'],
            'units_progress' => json_decode($row_progress['units_progress'],true)
        ];

        if($row_progress['unit_order'] > $unit_order){
            $relocate_unit_users[] = $row_progress['id_user']; 
            
        }
        if($row_progress['unit_order'] == $unit_order){
            $same_unit_users[] = $row_progress['id_user']; 
            
        }
        
    }
// CHECK WITCH WAY BEGIN
    $last_unit = false;
    
    if($max_order == $unit_order){
        $last_unit = true;
    }

    mysqli_begin_transaction($conn);

    // UPDATE USERS PROGRESS IN THE CURRENT UNIT
        // $sql_next_unit = "SELECT
        //     c.`id_content`,
        //     c.`order` as order_content,

        //     s.id_section,
        //     s.order as order_section,

        //     u.id_unit,
        //     u.order as order_unit,

        //     l.id_level,
        //     l.order as order_level

        //     FROM contents c
        //     INNER JOIN sections s USING(id_section)
        //     INNER JOIN units u USING(id_unit)
        //     INNER JOIN levels l USING(id_level)
        //     WHERE (
        //         (l.id_level = '{$id_level}' AND u.`order` > {$unit_order}) OR
        //         (l.order > ${level_order})
        //     ) AND
        //     c.`status` = 1 AND
        //     s.`status` = 1 AND
        //                     s.`order` > 0 AND
                // (u.`optional` = 0 OR u.`optional` IS NULL ) AND
        //     u.`status` = 1 AND
        //     l.`status` = 1 

        //     ORDER BY l.order ASC, u.`order` ASC, s.`order` ASC, c.`order` ASC
        //     LIMIT 1
        // ";
        // $result_next_unit = mysqli_query($conn,$sql_next_unit);
        // if(!$result_next_unit){
        //     $error = mysqli_error($conn);
        //     http_response_code(500);
        //     mysqli_rollback($conn);
        //     mysqli_close($conn);
        //     die(json_encode([
        //         'debug' => $error,
        //         'debug2' => 'next unit'
        //     ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        // }
        // $row_next_unit = mysqli_fetch_assoc($result_next_unit);

        // $new_level_order = $row_next_unit['order_level'];
        // $new_unit_order = $row_next_unit['order_unit'];
        // $new_section_order = $row_next_unit['order_section'];
        // $new_content_order = $row_next_unit['order_content'];
                ////
                $next_content_data = get_next_content_id($conn,[
                    'unit' => [ 'id' => $id_unit, 'order' => $unit_order ],
                    'level' => [ 'id' => $id_level, 'order' => $level_order ]
                ]);
    
                if($next_content_data['status'] != 200){
                    mysqli_rollback($conn);
                    mysqli_close($conn);
                    http_response_code($next_content_data['status']);
                    die(json_encode([
                        'debug' => $next_content_data['debug']
                    ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
                }
    
                $response_next_content = $next_content_data['response'];
    
                $new_level_order = $response_next_content['level']['order'];
                $new_unit_order = $response_next_content['unit']['order'];
                $new_section_order = $response_next_content['section']['order'];
                $new_content_order = $response_next_content['content']['order'];
            ////

        foreach($same_unit_users as $id_student){
        
            $user_progress = $all_users[$id_student];
            $unit_progress = $user_progress['units_progress'];
            
            unset($unit_progress[$id_unit]);

            $unit_progress = json_encode($unit_progress, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);

            $sql_update_progress = "CALL sp_update_progress(
                '{$id_user}',
                '{$id_student}',
                '{$new_level_order}',
                '{$new_unit_order}',
                '{$new_section_order}',
                '{$new_content_order}',
                '{$unit_progress}'
            )";

            $result_update_progress = mysqli_query($conn,$sql_update_progress);

            if(!$result_update_progress){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => $sql_update_progress
                ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
            }

            mysqli_next_result($conn);
        }

    // UPDATE USERS THAT MUST BE RELOCATED.
        foreach($relocate_unit_users as $id_student){
            delete_user_answers_by_unit_id($conn,$id_student,$id_unit);
        }
        $sql_relocate = "UPDATE user_progress SET unit_order = unit_order -1 WHERE level_order = {$level_order} AND unit_order >= {$unit_order}";
        $result_relocate = mysqli_query($conn,$sql_relocate);
        if(!$result_relocate){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'result_relocate'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }    
    // UPDATE UNITS ORDER
        $sql_units = "UPDATE units SET `order` = `order` - 1 WHERE id_level = '{$id_level}' AND `order` > {$unit_order}";
        $result_units = mysqli_query($conn,$sql_units);
        if(!$result_units){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'upodate_units'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    

// QUERIES
    $sql_delete_answers = "DELETE 
    FROM answers 
    WHERE id_content IN (
        SELECT c.id_content
        FROM contents c
        INNER JOIN sections s USING(id_section)
        INNER JOIN units u USING(id_unit)
        WHERE u.id_unit = '{$id_unit}'
    );";

    $sql_delete_contents = "DELETE 
    FROM contents 
    WHERE id_section IN (
        SELECT s.id_section
        FROM sections s
        INNER JOIN units u USING(id_unit)
        WHERE u.id_unit = '{$id_unit}'
    );";

    $sql_delete_sections = "DELETE 
    FROM sections 
    WHERE id_unit IN (
        SELECT u.id_unit
        FROM units u
        WHERE u.id_unit = '{$id_unit}'
    );";

    $sql_delete_units = "DELETE FROM units 
    WHERE id_unit = '{$id_unit}';";


    $result_delete_answers = mysqli_query($conn,$sql_delete_answers);
    $result_delete_contents = mysqli_query($conn,$sql_delete_contents);
    $result_delete_sections = mysqli_query($conn,$sql_delete_sections);
    $result_delete_units = mysqli_query($conn,$sql_delete_units);

    if(!$result_delete_answers){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'answers'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$result_delete_contents){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'contents'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$result_delete_sections){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'sections'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$result_delete_units){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'units'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);

    die();
    // die(json_encode([
    //     'order' => $unit_order,
    //     'relocate' => $relocate_unit_users,
    //     'same' => $same_unit_users,
    //     'all' => $all_users
    // ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>

