<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['id_level'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_level'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);
$id_level = mysqli_real_escape_string($conn,$json['id_level']);
// $id_user = 'a6c90136-f0c8-11ec-a869-00e04c0362fc';
// $id_unit = '07678cc9-f15b-11ec-a0db-00e04c0362fc';

// GET UNITS DATA
    $sql_units = "SELECT 
        l.`label` as level_label,
        l.`order` as level_order,
        l.`class_name`,
        u.`order` as unit_order,
        u.`label` as unit_label,
        u.`id_unit`
        FROM units u
        INNER JOIN levels l USING(id_level)
        WHERE u.`id_level` = '${id_level}'
        ORDER BY u.`order` ASC;
    ";

    $result_units = mysqli_query($conn,$sql_units);

    if(!$result_units){
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_sections
        ],JSON_UNESCAPED_UNICODE));
    }
    $units = [];
    while($row_units = mysqli_fetch_assoc($result_units)){
        $units[] = [
            'id_unit' => $row_units['id_unit'],
            'level_label' => $row_units['level_label'],
            'level_order' => $row_units['level_order'],
            'unit_label' => $row_units['unit_label'],
            'unit_order' => $row_units['unit_order'],
            'color_class' => $row_units['class_name']
        ];
    }




// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode($units,JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));


?>