<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
$json = json_decode($json,true);

if(empty($json['id_user'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);

// TEST USER PERMITION
    $test_permition = test_permition($conn,$id_user,3);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
// GET USERS DATA
    $users_list = array();
    $sql_users = "SELECT
    u.id_user,
    u.name,
    u.email,
    u.phone,
    g.label
    FROM users u
    INNER JOIN groups g USING(id_group)
    WHERE (g.level > 0)
    ORDER BY u.created_at DESC;";

    $result_users = mysqli_query($conn,$sql_users);

    if(!$result_users){
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_users
        ],JSON_UNESCAPED_UNICODE));
    }

    while($row_user = mysqli_fetch_assoc($result_users)){

        // $sql_access = "SELECT created_at FROM answers WHERE id_user = '{$row_user['id_user']}' ORDER BY created_at DESC LIMIT 1";
        // $result_access = mysqli_query($conn,$sql_access);
        // if(!$result_access){
        //     http_response_code(500);
        //     die(json_encode([
        //         'debug' => $sql_access
        //     ],JSON_UNESCAPED_UNICODE));
        // }

        // $last_access = null;

        // if(mysqli_num_rows($result_access) > 0){
        //     $row_access = mysqli_fetch_assoc($result_access);
        //     $last_access = $row_access['created_at'];
        // }

        $users_list[] = [
            'id' => $row_user['id_user'],
            'name' => $row_user['name'],
            'email' => $row_user['email'],
            'phone' => $row_user['phone'],
            'group' => $row_user['label'],
        ];

    }
// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode([
        "users_list" => $users_list
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>