<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
$json = json_decode($json,true);

if(empty($json['id_user'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_student'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_student'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_student = mysqli_real_escape_string($conn,$json['id_student']);

// TEST USER PERMITION
    if($id_user != $id_student){
        $test_permition = test_permition($conn,$id_user,1);
        if($test_permition['status'] != 200){
            mysqli_close($conn);
            http_response_code(500);
            die(json_encode([
                'debug' => $test_permition
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
        if(!$test_permition['response']['permition']){
            mysqli_close($conn);
            http_response_code(403);
            die(json_encode([
                'debug' => 'permition'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    }
    
// GET USERS DATA
    $sql_users = "SELECT
    u.id_user,
    u.name,
    u.email,
    u.phone,
    u.last_access,
    u.birth_date,
    u.city,
    u.state,
    u.cpf,
    g.label,
    g.level,
    c.label as code,
    up.units_progress,
    up.`level_order`,
    up.`unit_order`,
    up.`section_order`,
    up.`content_order`,
    up.`units_progress`,
    up.updated_at as progress_updated_at, 
    u.updated_at as user_updated_at
    FROM users u
    INNER JOIN groups g USING(id_group)
    LEFT JOIN user_progress up ON u.id_user = up.id_user
    LEFT JOIN codes c ON c.id_code = u.id_code
    WHERE (g.level = 0 OR g.level = -1) AND u.id_user =  '{$id_student}'
    ORDER BY u.created_at DESC;";

    $result_users = mysqli_query($conn,$sql_users);

    if(!$result_users){
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_users
        ],JSON_UNESCAPED_UNICODE));
    }
    $user_data = array();
    while($row_user = mysqli_fetch_assoc($result_users)){
        $user_data = [
            'id' => $row_user['id_user'],
            'name' => $row_user['name'],
            'birth_date' => $row_user['birth_date'] ? date('d/m/Y',strtotime($row_user['birth_date'])) : null,
            'cpf' => $row_user['cpf'],
            'email' => $row_user['email'],
            'city' => $row_user['city'],
            'state' => $row_user['state'],
            'phone' => $row_user['phone'],
            'last_access' => $row_user['last_access'],
            'group_label' => $row_user['label'],
            'group' => $row_user['level'],
            'code' => $row_user['code'],
            'units_progress' => json_decode($row_user['units_progress']),
            'progress_updated_at' => $row_user['progress_updated_at'] ? date('d/m/Y',$row_user['progress_updated_at']) : null,
            'user_updated_at' => $row_user['user_updated_at'] ? date('d/m/Y',$row_user['user_updated_at']) : null,
            'progress' => [
                'level' => $row_user['level_order'],
                'unit' => $row_user['unit_order'],
                'section' => $row_user['section_order'],
                'content' => $row_user['content_order']
            ]
        ]; 
    }
// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode([
        "user_data" => $user_data
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>