<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../../config/db-connection.php';
include_once __DIR__ . '/../../../config/https_environment.php';
include_once __DIR__ . '/../../../utils/utils.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['code_data'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'code_data'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$code_data = $json['code_data'];

if(isset($code_data['label'])){
    $label = mysqli_real_escape_string($conn,$code_data['label']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'label'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

// TEST USER PERMITION
    $test_permition = test_permition($conn,$id_user,3);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

$sql_create = "INSERT INTO codes(id_code,label) VALUE(UUID(),'{$label}')";

$result_create = mysqli_query($conn,$sql_create);

if(!$result_create){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug_sql' => $sql_create
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

