<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

// CAPTURA PERMISSÕES
$test_permition = test_permition($conn,$id_user,2);
if($test_permition['status'] != 200){
    mysqli_close($conn);
    http_response_code(500);
    die(json_encode([
        'debug' => $test_permition
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['id_student'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_student'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_student = mysqli_real_escape_string($conn,$json['id_student']);

// CHECK STUDENT GROUP LEVEL
$sql_group      = "SELECT g.level, u.editor FROM users u INNER JOIN `groups` g USING(id_group) WHERE u.id_user = '{$id_student}';";
$result_group   = mysqli_query($conn,$sql_group);

if(!$result_group){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE));
}
$row_group = mysqli_fetch_assoc($result_group);
$group_level = $row_group['level'];

if($group_level > 1){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_student level'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

mysqli_begin_transaction($conn);

//START UPLOAD
$sql_update_logs        = "UPDATE system_logs SET id_user_agent = '37e44344-f0c5-11ec-a869-00e04c0362fc' WHERE id_user_agent = '{$id_student}'";
if(!mysqli_query($conn,$sql_update_logs)){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE));
}
//START DELETE
$sql_delete_progress = "DELETE FROM user_progress WHERE id_user = '{$id_student}';";
if(!mysqli_query($conn,$sql_delete_progress)){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE));
} 
$sql_delete_answers = "DELETE FROM answers WHERE id_user = '{$id_student}';";
if(!mysqli_query($conn,$sql_delete_answers)){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE));
} 
$sql_delete_student = "DELETE FROM users WHERE id_user = '{$id_student}';";
if(!mysqli_query($conn,$sql_delete_student)){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE));
} 

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);
die();