<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);
// CAPTURA PERMISSÕES
$test_permition = test_permition($conn,$id_user,2);
if($test_permition['status'] != 200){
    mysqli_close($conn);
    http_response_code(500);
    die(json_encode([
        'debug' => $test_permition
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['id_student'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_student'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_student = mysqli_real_escape_string($conn,$json['id_student']);

if(empty($json['student_data'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'student_data'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$student_data = $json['student_data'];

if(isset($student_data['cpf'])){
    $cpf = mysqli_real_escape_string($conn,$student_data['cpf']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'cpf'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['name'])){
    $name = mysqli_real_escape_string($conn,$student_data['name']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'name'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['birth'])){
    $birth = mysqli_real_escape_string($conn,$student_data['birth']);
    $birth = str_replace('/','-',$birth);
    $birth = strtotime($birth);
    $birth = date('Y-m-d',$birth);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'birth'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['email'])){
    $email = mysqli_real_escape_string($conn,$student_data['email']);



}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'email'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['phone'])){
    $phone = mysqli_real_escape_string($conn,$student_data['phone']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'phone'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


if(isset($student_data['city'])){
    $city = mysqli_real_escape_string($conn,$student_data['city']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'city'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['state'])){
    $state = mysqli_real_escape_string($conn,$student_data['state']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'state'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$update_group = '';
if(isset($student_data['group'])){
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'do not have permition to change the group code'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $group = mysqli_real_escape_string($conn,$student_data['group']);

    $group = intval($group);
    if($group != 0){
        $group = -1;
    }else{
        $group = 0;
    }

    $sql_group = "SELECT id_group FROM `groups` WHERE `level` = {$group} LIMIT 1";
    $result_group = mysqli_query($conn,$sql_group);

    if(!$result_group){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug_sql' => $error,
            'debug' => 'error getting group id',
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $row_group = mysqli_fetch_assoc($result_group);

    $id_group = $row_group['id_group'];
    $update_group = "id_group = '{$id_group}',";
}


if(isset($student_data['password'])){
    $password = mysqli_real_escape_string($conn,$student_data['password']);
}

// TEST USER PERMITION
    if($id_user != $id_student){
        if(!$test_permition['response']['permition']){
            mysqli_close($conn);
            http_response_code(403);
            die(json_encode([
                'debug' => 'permition'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    }
//


$sql_verify = "SELECT id_user FROM users WHERE email = '{$email}' AND id_user != '{$id_student}';";

$result_verify = mysqli_query($conn,$sql_verify);
if(!$result_verify){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => 'email verify',
        'debug_error' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(mysqli_num_rows($result_verify) > 0){
    $error = mysqli_error($conn);
    http_response_code(400);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'message' => 'O endereço de e-mail já está em uso.'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


if(isset($student_data['password']) && $student_data['password'] != ""){
    $sql_edit = "UPDATE users u SET
                `name` = '{$name}',
                `email` = '{$email}',
                `password` = md5('{$password}'),
                `birth_date` = '{$birth}',
                `city` = '{$city}',
                `state` = '{$state}',
                `phone` = '{$phone}',
                {$update_group}
                `updated_at` = default
            WHERE id_user = '{$id_student}';";

}else{
    $sql_edit = "UPDATE users u SET
                `name` = '{$name}',
                `email` = '{$email}',
                `birth_date` = '{$birth}',
                `city` = '{$city}',
                `state` = '{$state}',
                `phone` = '{$phone}',
                {$update_group}
                `updated_at` = default
            WHERE id_user = '{$id_student}';";
}
$result_edit = mysqli_query($conn,$sql_edit);

if(!$result_edit){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

