<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../../config/db-connection.php';
include_once __DIR__ . '/../../../config/https_environment.php';
include_once __DIR__ . '/../../../utils/utils.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);
// CAPTURA PERMISSÕES


if(empty($json['id_email_template'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_email_template'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_email_template = mysqli_real_escape_string($conn,$json['id_email_template']);

if(empty($json['subject'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'subject'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$subject = mysqli_real_escape_string($conn,$json['subject']);

if(empty($json['email_data'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'email_data'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$email_data = $json['email_data'];

if(isset($email_data['content'])){
    $content = mysqli_real_escape_string($conn,$email_data['content']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'content'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

// TEST USER PERMITION
    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

$sql_edit = "UPDATE email_templates SET
            content = '{$content}',
            `subject` = '{$subject}'
        WHERE id_email_template = '{$id_email_template}';";

$result_edit = mysqli_query($conn,$sql_edit);

if(!$result_edit){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $sql_edit        
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

