<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../../config/db-connection.php';
include_once __DIR__ . '/../../../config/https_environment.php';
include_once __DIR__ . '/../../../utils/utils.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['code'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'code'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_code = mysqli_real_escape_string($conn,$json['code']);

if(empty($json['password'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'password'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$password = mysqli_real_escape_string($conn,$json['password']);


$sql = "SELECT recover_time, id_user FROM users WHERE `recover_code` = '${id_code}' LIMIT 1;";
$result = mysqli_query($conn,$sql);

if(!$result){
    http_response_code(500);
    $error = mysqli_error($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE));
}

if(mysqli_num_rows($result) < 1){
    http_response_code(403);
    die();
}

$row = mysqli_fetch_assoc($result);

$timestamp = $row['recover_time'];
$id_user = $row['id_user'];

$limit = $timestamp + (24*60*60);

if(time() > $limit ){
    http_response_code(403);
    die();
}


mysqli_begin_transaction($conn);
$sql_update = "UPDATE users SET recover_code = null, recover_time = null, `password` = MD5('{$password}')  WHERE `id_user` = '${id_user}';";
$result_update = mysqli_query($conn,$sql_update);
if(!$result_update){
    http_response_code(500);
    $error = mysqli_error($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE));
}

http_response_code(200);
mysqli_commit($conn);
die();

?>
