<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);

$sql_progress = "SELECT 
    `id_user`,
    `level_order`,
    `unit_order`,
    `section_order`,
    `content_order`,
    `units_progress`
    FROM user_progress WHERE `id_user` = '${id_user}';
";

$result_progress = mysqli_query($conn,$sql_progress);

if(!$result_progress){
    http_response_code(500);
    die(json_encode([
        'debug' => 'erro na query, ' . $sql_progress
    ],JSON_UNESCAPED_UNICODE));
}

$json_progress = [];
if(mysqli_num_rows($result_progress) > 0){
    $row_progress = mysqli_fetch_assoc($result_progress);

    $json_progress['progress']['level'] = $row_progress['level_order'];
    $json_progress['progress']['unit'] = $row_progress['unit_order'];
    $json_progress['progress']['section'] = $row_progress['section_order'];
    $json_progress['progress']['content'] = $row_progress['content_order'];

    $json_progress['unitProgress'] = $row_progress['units_progress'];

    http_response_code(200);
    die(json_encode($json_progress,JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));

}else{

    $sql_create_progress = "CALL sp_create_progress('${id_user}','${id_user}');";

    $result_create_progress = mysqli_query($conn,$sql_create_progress);

    if(!$result_create_progress){
        http_response_code(500);
        die(json_encode([

            'debug' => 'erro na query, ' . mysqli_error($conn)
        ],JSON_UNESCAPED_UNICODE));
    }

    $json_progress['progress']['level'] = 1;
    $json_progress['progress']['unit'] = 1;
    $json_progress['progress']['section'] = 1;
    $json_progress['progress']['content'] = 1;

    $json_progress['unitProgress'] = null;

    die(json_encode($json_progress,JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));

}

?>