<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();


// GET FIRST CONTENT 
$sql_content = "SELECT
                u.id_unit,
                s.id_section,
                c.id_content
                FROM contents c
                INNER JOIN sections s USING(id_section)
                INNER JOIN units u USING(id_unit)
                INNER JOIN levels l USING(id_level)
                WHERE 
                    l.status = 1 AND
                    u.`status` = 1 AND
                    s.`status` = 1 AND
                    c.`status` = 1
                ORDER BY l.order ASC, u.order ASC, s.order ASC, c.order ASC, s.created_at ASC
                LIMIT 1;
";

$result_content = mysqli_query($conn,$sql_content);

if(!$result_content){
    http_response_code(500);
    $error = mysqli_error($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
}

if(mysqli_num_rows($result_content) < 1){
    http_response_code(403);
    die();
}

$row_content = mysqli_fetch_assoc($result_content);

$json_content = [
    'id_unit' => $row_content['id_unit'],
    'id_section' => $row_content['id_section'],
    'id_content' => $row_content['id_content']
];

http_response_code(200);
die(json_encode($json_content,JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));

?>

