<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);


if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);


if(empty($json['id_section'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_section'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_section = mysqli_real_escape_string($conn,$json['id_section']);

if(empty($json['contentData']['title'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'title'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$title = mysqli_real_escape_string($conn,$json['contentData']['title']);

if(empty($json['contentData']['order'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'order'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$order = mysqli_real_escape_string($conn,$json['contentData']['order']);

if(empty($json['contentData']['active'])){
    $active = 0;
}else{
    if($json['contentData']['active'] == true){
        $active = 1;
    }else{
        $active = 0;
    }
}


$type = mysqli_real_escape_string($conn,$json['contentData']['type']);

if(is_nan($type)){
    http_response_code(400);
    die(json_encode([
        'debug' => 'type'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['contentData']['meta'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'meta'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$meta = $json['contentData']['meta'];

if(gettype($meta) != 'array'){
    http_response_code(400);
    die(json_encode([
        'debug' => 'meta2'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$meta = json_encode($meta, JSON_HEX_QUOT | JSON_HEX_TAG);
$meta = addslashes($meta);

// GET MAX ORDER
$sql_order = "SELECT max(c.order) as max_order FROM contents c INNER JOIN sections s USING(id_section) WHERE s.id_section = '${id_section}'";

$result_order = mysqli_query($conn,$sql_order);

if(!$result_order){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$row_content = mysqli_fetch_assoc($result_order);
$max_order = $row_content['max_order'];
$max_order = intval($max_order) + 1;
// END GET


$sql_create = "CALL sp_create_content('{$id_user}','{$id_section}','{$title}','{$meta}',{$max_order},{$type},{$active})";

$result_create = mysqli_query($conn,$sql_create);

if(!$result_create){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

