<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_content'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_content'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_content = mysqli_real_escape_string($conn,$json['id_content']);

// TEST USER PERMITION
        $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

// GET SECTION & LEVEL ORDER 
    $sql_orders = "SELECT l.id_level,
     l.order as level_order,
     u.order as unit_order,
     u.id_unit,
     s.order as section_order,
     s.id_section,
     c.order as content_order
     FROM levels l INNER JOIN units u USING(id_level) INNER JOIN sections s USING(id_unit) INNER JOIN contents c USING(id_section) WHERE c.id_content = '{$id_content}'";
    $result_orders = mysqli_query($conn,$sql_orders);
    if(!$result_orders){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'orders'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $row_orders = mysqli_fetch_assoc($result_orders);
    $content_order = $row_orders['content_order'];

    $id_section = $row_orders['id_section'];
    $section_order = $row_orders['section_order'];

    $id_level = $row_orders['id_level'];
    $level_order = $row_orders['level_order'];

    $id_unit = $row_orders['id_unit'];
    $unit_order = $row_orders['unit_order'];

// GET MAX ORDER
    $sql_order = "SELECT max(`order`) as max_order FROM contents WHERE id_section = '{$id_section}'";

    $result_order = mysqli_query($conn,$sql_order);

    if(!$result_order){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $row_order = mysqli_fetch_assoc($result_order);
    $max_order = $row_order['max_order'];
// GET USERS FROM THIS SECTION
    $sql_progress = "SELECT up.id_user,
        up.level_order,
        up.unit_order,
        up.section_order,
        up.content_order,
        up.units_progress,
        u.id_unit,
        s.id_section,
        c.id_content
    FROM user_progress up
    INNER JOIN levels l ON up.level_order = l.order 
    INNER JOIN units u ON l.id_level = u.id_level
    INNER JOIN sections s ON s.id_unit = u.id_unit
    INNER JOIN contents c ON c.id_section = s.id_section
    WHERE up.level_order = {$level_order}
    AND up.unit_order = {$unit_order}
    AND up.section_order = {$section_order}
    GROUP BY up.id_user";

    $result_progress = mysqli_query($conn,$sql_progress);
    if(!$result_progress){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'users list'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $all_users = array();
    $same_section_users = array();
    $relocate_section_users = array();

    while($row_progress = mysqli_fetch_assoc($result_progress)){

        $all_users[$row_progress['id_user']] = [
            'id_user' => $row_progress['id_user'],
            'level_order' => $row_progress['level_order'],
            'unit_order' => $row_progress['unit_order'],
            'section_order' => $row_progress['section_order'],
            'content_order' => $row_progress['content_order'],
            'id_unit' => $row_progress['id_unit'],
            'id_section' => $row_progress['id_section'],
            'id_content' => $row_progress['id_content'],
            'units_progress' => json_decode($row_progress['units_progress'],true)
        ];

        if($row_progress['content_order'] > $content_order){
            $relocate_section_users[] = $row_progress['id_user']; 
            
        }
        if($row_progress['content_order'] == $content_order){
            $same_section_users[] = $row_progress['id_user']; 
            
        }
        
    }
// CHECK WITCH WAY BEGIN
    $last_unit = false;
    
    if($max_order == $unit_order){
        $last_unit = true;
    }

    mysqli_begin_transaction($conn);

    // UPDATE USERS PROGRESS IN THE CURRENT CONTENT
        $sql_next_unit = "SELECT
            c.`id_content`,
            c.`order` as order_content,

            s.id_section,
            s.order as order_section,

            u.id_unit,
            u.order as order_unit,

            l.id_level,
            l.order as order_level

            FROM contents c
            INNER JOIN sections s USING(id_section)
            INNER JOIN units u USING(id_unit)
            INNER JOIN levels l USING(id_level)
            WHERE (
                (c.id_section = '{$id_section}' AND c.`order` > {$content_order}) OR
                (s.id_unit = '{$id_unit}' AND s.`order` > {$section_order}) OR
                (l.id_level = '{$id_level}' AND u.order > ${unit_order}) OR
                (l.order > {$level_order})

            ) AND
            c.`status` = 1 AND
            s.`status` = 1 AND
                            s.`order` > 0 AND
                (u.`optional` = 0 OR u.`optional` IS NULL ) AND
            u.`status` = 1 AND
            l.`status` = 1 

            ORDER BY u.`order` ASC, s.`order` ASC, c.`order` ASC
            LIMIT 1
        ";
        ////
            $next_content_data = get_next_content_id($conn,[
                'content' => [ 'id' => $id_content, 'order' => $content_order ],
                'section' => [ 'id' => $id_section, 'order' => $section_order ],
                'unit' => [ 'id' => $id_unit, 'order' => $unit_order ],
                'level' => [ 'id' => $id_level, 'order' => $level_order ]
            ]);

            if($next_content_data['status'] != 200){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code($next_content_data['status']);
                die(json_encode([
                    'debug' => $next_content_data['debug']
                ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
            }

            $response_next_content = $next_content_data['response'];

            $new_level_order = $response_next_content['level']['order'];
            $new_unit_order = $response_next_content['unit']['order'];
            $new_section_order = $response_next_content['section']['order'];
            $new_content_order = $response_next_content['content']['order'];

            
        ////
        // $result_next_unit = mysqli_query($conn,$sql_next_unit);
        // if(!$result_next_unit){
        //     $error = mysqli_error($conn);
        //     http_response_code(500);
        //     mysqli_rollback($conn);
        //     mysqli_close($conn);
        //     die(json_encode([
        //         'debug' => $error,
        //         'debug2' => 'next unit'
        //     ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        // }
        // $row_next_unit = mysqli_fetch_assoc($result_next_unit);

        // $new_level_order = $row_next_unit['order_level'];
        // $new_unit_order = $row_next_unit['order_unit'];
        // $new_section_order = $row_next_unit['order_section'];
        // $new_content_order = $row_next_unit['order_content'];

        foreach($same_section_users as $id_student){
        
            $user_progress = $all_users[$id_student];
            $unit_progress = $user_progress['units_progress'];
            

            $unit_progress = json_encode($unit_progress, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);

            $sql_update_progress = "CALL sp_update_progress(
                '{$id_user}',
                '{$id_student}',
                '{$new_level_order}',
                '{$new_unit_order}',
                '{$new_section_order}',
                '{$new_content_order}',
                '{$unit_progress}'
            )";

            $result_update_progress = mysqli_query($conn,$sql_update_progress);

            if(!$result_update_progress){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => $sql_update_progress
                ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
            }

            mysqli_next_result($conn);
        }

    // UPDATE USERS THAT MUST BE RELOCATED.
        foreach($relocate_section_users as $id_student){
            delete_user_answers_by_content_id($conn,$id_student,$id_content);
        }
        $sql_relocate = "UPDATE user_progress SET content_order = content_order -1 WHERE level_order = {$level_order} AND unit_order = {$unit_order} AND section_order = {$section_order} AND content_order >= {$content_order}";
        $result_relocate = mysqli_query($conn,$sql_relocate);
        if(!$result_relocate){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'result_relocate'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }    
    // UPDATE SECTION ORDER
        $sql_units = "UPDATE contents SET `order` = `order` - 1 WHERE id_section = '{$id_section}' AND `order` > {$content_order}";
        $result_units = mysqli_query($conn,$sql_units);
        if(!$result_units){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'update_sections'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    

// QUERIES
    $sql_delete_answers = "DELETE 
    FROM answers 
    WHERE id_content = '{$id_content}';";

    $sql_delete_contents = "DELETE 
    FROM contents 
    WHERE id_content = '{$id_content}';";


    $result_delete_answers = mysqli_query($conn,$sql_delete_answers);
    if(!$result_delete_answers){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'answers'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $result_delete_contents = mysqli_query($conn,$sql_delete_contents);
    if(!$result_delete_contents){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error,
            'debug2' => 'contents'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

// END OPERATION

    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);

    die();

?>

