<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);


if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);


if(empty($json['id_content'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_content'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_content = mysqli_real_escape_string($conn,$json['id_content']);

if(empty($json['contentData']['title'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'title'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$title = mysqli_real_escape_string($conn,$json['contentData']['title']);

if(empty($json['contentData']['active'])){
    $active = 0;
}else{
    if($json['contentData']['active'] == true){
        $active = 1;
    }else{
        $active = 0;
    }
}

$type = mysqli_real_escape_string($conn,$json['contentData']['type']);

if(is_nan($type)){
    http_response_code(400);
    die(json_encode([
        'debug' => 'type'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['contentData']['meta'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'meta'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$meta = $json['contentData']['meta'];

if(gettype($meta) != 'array'){
    http_response_code(400);
    die(json_encode([
        'debug' => 'meta2'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$meta = json_encode($meta, JSON_HEX_QUOT | JSON_HEX_TAG);
$meta = addslashes($meta);

if(empty($json['contentData']['order'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'order'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$order = mysqli_real_escape_string($conn,$json['contentData']['order']);

// ORDER VERIFY
    $sql_order = "SELECT `order`, `status` FROM contents WHERE id_content = '${id_content}'";

    $result_order = mysqli_query($conn,$sql_order);

    if(!$result_order){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $row_content = mysqli_fetch_assoc($result_order);
    $old_order = $row_content['order'];
    $old_active = $row_content['status'];

    if ($old_active == 1 && $active == 0){
        // GET SECTION & LEVEL ORDER 
        $sql_orders = "SELECT l.id_level,
            l.order as level_order,
            u.order as unit_order,
            u.id_unit,
            s.order as section_order,
            s.id_section,
            c.order as content_order
            FROM levels l INNER JOIN units u USING(id_level) INNER JOIN sections s USING(id_unit) INNER JOIN contents c USING(id_section) WHERE c.id_content = '{$id_content}'";
        $result_orders = mysqli_query($conn,$sql_orders);
        if(!$result_orders){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'orders'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
        $row_orders = mysqli_fetch_assoc($result_orders);
        $content_order = $row_orders['content_order'];

        $id_section = $row_orders['id_section'];
        $section_order = $row_orders['section_order'];

        $id_level = $row_orders['id_level'];
        $level_order = $row_orders['level_order'];

        $id_unit = $row_orders['id_unit'];
        $unit_order = $row_orders['unit_order'];

        //check if it can change the order
        $sql_check = "SELECT up.id_user
        FROM user_progress up
        INNER JOIN levels l ON up.level_order = l.order 
        INNER JOIN units u ON l.id_level = u.id_level
        INNER JOIN sections s ON s.id_unit = u.id_unit
        INNER JOIN contents c ON c.id_section = s.id_section
        WHERE up.level_order = {$level_order}
        AND up.unit_order = {$unit_order}
        AND up.section_order = {$section_order}
        AND up.content_order = {$content_order}
        GROUP BY up.id_user;";
    
        $result_check = mysqli_query($conn,$sql_check);
    
        if(!$result_check){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    
        if(mysqli_num_rows($result_check) > 0){
            http_response_code(400);
            die(json_encode([
                'message' => 'Você não pode inativar um conteúdo em que haja alunos cursando no momento'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    }

    if($old_order != $order){


        if($active == 0){
            http_response_code(400);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'message' => 'Você não pode alterar a ordenação de um conteúdo inativo'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }

        // GET SECTION & LEVEL ORDER 
        $sql_orders = "SELECT l.id_level,
            l.order as level_order,
            u.order as unit_order,
            u.id_unit,
            s.order as section_order,
            s.id_section,
            c.order as content_order
            FROM levels l INNER JOIN units u USING(id_level) INNER JOIN sections s USING(id_unit) INNER JOIN contents c USING(id_section) WHERE c.id_content = '{$id_content}'";
        
        $result_orders = mysqli_query($conn,$sql_orders);
        
        if(!$result_orders){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'orders'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }

        $row_orders = mysqli_fetch_assoc($result_orders);
        $content_order = $row_orders['content_order'];

        $id_section = $row_orders['id_section'];
        $section_order = $row_orders['section_order'];

        $id_level = $row_orders['id_level'];
        $level_order = $row_orders['level_order'];

        $id_unit = $row_orders['id_unit'];
        $unit_order = $row_orders['unit_order'];



        //check if it can change the order
        $sql_check = "SELECT up.id_user
        FROM user_progress up
        INNER JOIN levels l ON up.level_order = l.order 
        INNER JOIN units u ON l.id_level = u.id_level
        INNER JOIN sections s ON s.id_unit = u.id_unit
        INNER JOIN contents c ON c.id_section = s.id_section
        WHERE up.level_order = {$level_order}
        AND up.unit_order = {$unit_order}
        AND up.section_order = {$section_order}
        GROUP BY up.id_user;";
    
        $result_check = mysqli_query($conn,$sql_check);

        if(!$result_check){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    



        if(mysqli_num_rows($result_check) > 0){

            
            // GET NEXT CONTENT ORDER
            $next_content_data = get_next_content_id($conn,[
                'section' => [ 'id' => $id_section, 'order' => $section_order ],
                'unit'    => [ 'id' => $id_unit, 'order' => $unit_order ],
                'level'   => [ 'id' => $id_level, 'order' => $level_order ]
            ]);

            if($next_content_data['status'] != 200){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code($next_content_data['status']);
                die(json_encode([
                    'debug' => $next_content_data['debug']
                ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
            }

            $response_next_content = $next_content_data['response'];
            $att_key = $response_next_content['att_key'];

            if($att_key != 'end'){
                $next_level_order   =       isset($response_next_content['level'])   ?    intval($response_next_content['level']['order']) : 0;
                $next_unit_order    =       isset($response_next_content['unit'])    ?    intval($response_next_content['unit']['order']) : 0;
                $next_section_order =       isset($response_next_content['section']) ?    intval($response_next_content['section']['order']) : 0;
                $next_content_order =       isset($response_next_content['content']) ?    intval($response_next_content['content']['order']) : 0;
            }else{
                $res_last_content = get_last_content($conn);
                if($res_last_content['status'] != 200){
                    mysqli_close($conn);
                    die(json_encode([
                        'debug' => 'last_content'
                    ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
                }

                $last_content_object = $res_last_content['response'];
            
                $next_level_order = $last_content_object['level']['order'];
                $next_unit_order = $last_content_object['unit']['order'];
                $next_section_order = $last_content_object['section']['order'];
                $next_content_order = $last_content_object['content']['order'];
            }

            $sql_user_update = 
            "   UPDATE user_progress 

                SET level_order = {$next_level_order},
                    unit_order = {$next_unit_order},
                    section_order = {$next_section_order},
                    content_order = {$next_content_order}

                WHERE level_order = {$level_order}
                AND unit_order = {$unit_order}
                AND section_order = {$section_order}
            ";
            $result_user_update = mysqli_query($conn,$sql_user_update);

            if(!$result_user_update){
                http_response_code(500);
                mysqli_rollback($conn);
                mysqli_close($conn);
                die(json_encode([
                    'debug' => 'update user progress na section' . mysqli_error($conn) 
                ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
            }

        }


        
        $sql_update_section = "UPDATE contents SET `order` = {$order} WHERE id_content = '{$id_content}'";
        if($old_order > $order){
            $sql_update_sections = "UPDATE contents SET `order` = `order` + 1 WHERE id_section = '{$id_section}' AND `order` < {$old_order} AND `order` >= {$order} AND id_content NOT IN ('{$id_content}')";
        }else{
            $sql_update_sections = "UPDATE contents SET `order` = `order` - 1 WHERE id_section = '{$id_section}' AND `order` > {$old_order} AND `order` <= {$order} AND id_content NOT IN ('{$id_content}')";
        }

        // http_response_code(500);
        // mysqli_rollback($conn);
        // mysqli_close($conn);
        // die(json_encode([
        //     'debug' => $sql_update_section . ' | ' . $sql_update_sections
        // ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));

        $result_update_section = mysqli_query($conn,$sql_update_section);

        if(!$result_update_section){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => '2 - ' . mysqli_error($conn)
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
        
        $result_update_sections = mysqli_query($conn,$sql_update_sections);
        
        if(!$result_update_sections){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => '1 - ' . mysqli_error($conn)
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
        
        

    }

// END GET

$sql_create = "CALL sp_update_content('{$id_content}','{$id_user}','{$title}',\"{$meta}\",{$order},{$type},{$active})";
// $sql_create = "UPDATE contents s SET
//         `title` = '{$title}',
//         `meta` = '{$meta}',
//         `order` = {$old_order},
//         `type` = {$type},
//         `status` = {$active},
//         updated_at = default
//     WHERE id_content = '{$id_content}';
// ";

$result_create = mysqli_query($conn,$sql_create);

if(!$result_create){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

