<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');


include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['id_section'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_section'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);
$id_section = mysqli_real_escape_string($conn,$json['id_section']);
// $id_user = 'a6c90136-f0c8-11ec-a869-00e04c0362fc';
// $id_unit = '07678cc9-f15b-11ec-a0db-00e04c0362fc';

// GET SECTION CONTENTS DATA
$sql_contents = "SELECT
    l.`class_name`,
    c.order,
    c.title,
    c.id_content
    FROM contents c
    INNER JOIN sections s USING(id_section)
    INNER JOIN units u USING(id_unit)
    INNER JOIN levels l USING(id_level)
    WHERE c.`id_section` = '${id_section}'
    ORDER BY c.`order` ASC;
";

$result_contents = mysqli_query($conn,$sql_contents);

if(!$result_contents){
    http_response_code(500);
    die(json_encode([
        'debug' => $sql_contents
    ],JSON_UNESCAPED_UNICODE));
}

while($row_contents = mysqli_fetch_assoc($result_contents)){
    $color_class = $row_contents['class_name'];

    $order = $row_contents['order'];
    $title = $row_contents['title'];
    $id_content = $row_contents['id_content'];

    $json_contents[] = [
        "id_content" => $id_content,
        "label" =>  $title,
        "order" =>  $order,
        "color_class" => $color_class
    ];
}


// END OPERATION
header('Content-Type: application/json; charset=utf-8');
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode($json_contents,JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>