<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../utils/utils.php';

// //CHECK API KEY
// test_header_key();

$sql_levels = "SELECT l.id_level, 
    l.label, 
    l.order, 
    l.class_name, 
    l.icon, 
    l.status 
    FROM levels l
    INNER JOIN units u USING(id_level)
    INNER JOIN sections s USING(id_unit)
    INNER JOIN contents c USING(id_section)
    WHERE 
        l.status = 1 AND
        u.status = 1 AND
        s.status = 1 AND
        c.status = 1
    GROUP BY l.id_level
    ORDER BY l.order";

$result_levels = mysqli_query($conn,$sql_levels);

if(!$result_levels){
    $error = mysqli_error($conn);
    mysqli_close($conn);
    http_response_code(500);
    die(json_encode([
        'debug' => 'erro na query, ' . $error
    ],JSON_UNESCAPED_UNICODE));
}

$json_levels = [];

while($row_level = mysqli_fetch_assoc($result_levels)){
    //DEFINE DADOS DO LEVEL
    $id_level = $row_level['id_level'];
    $label_level = $row_level['label'];
    $order_level = $row_level['order'];
    $class_level = $row_level['class_name'];
    $icon_level = $row_level['icon'];
    
    $json_levels[$label_level]['id'] = $id_level;
    $json_levels[$label_level]['order'] = $order_level;
    $json_levels[$label_level]['colorClass'] = $class_level;
    $json_levels[$label_level]['iconClass'] = $icon_level;

    // BUSCA DADOS DAS UNITS
    $sql_units = "SELECT u.label,
     SUM(s.order) as exercice_qtd,
     u.id_unit,
     u.order,
     u.optional
     FROM units u 
     INNER JOIN sections s USING(id_unit)
     INNER JOIN contents c USING(id_section)
     WHERE u.id_level = '${id_level}' AND 
     u.status = 1 AND
     s.status = 1 AND
     c.status = 1
     GROUP BY u.id_unit
     ORDER BY u.`order`;";

    $result_units = mysqli_query($conn,$sql_units);

    if(!$result_units){
        $error = mysqli_error($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => 'erro na query, ' . $error
        ],JSON_UNESCAPED_UNICODE));
    }

    while($row_unit = mysqli_fetch_assoc($result_units)){
        $label_unit = $row_unit['label'];
        $order_unit = $row_unit['order'];
        $exercice_qtd = $row_unit['exercice_qtd'];
        $optional_unit = $row_unit['optional'];
        $id_unit = $row_unit['id_unit'];

        // DEFINE DADOS DA UNIT
        $json_levels[$label_level]['units'][$label_unit]['exercice_qtd'] = $exercice_qtd;
        $json_levels[$label_level]['units'][$label_unit]['order'] = $order_unit;
        $json_levels[$label_level]['units'][$label_unit]['optional'] = $optional_unit;
        $json_levels[$label_level]['units'][$label_unit]['id'] = $id_unit;

    }

}

//LAST CONTENT
    $last_content = [];

    $res_last_content = get_last_content($conn);
    if($res_last_content['status'] != 200){
        mysqli_close($conn);
        die(json_encode([
            'debug' => 'last_content'
        ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
    }
    $last_content_object = $res_last_content['response'];

    $last_content = [
        'level' => $last_content_object['level']['order'],
        'unit' => $last_content_object['unit']['order'],
        'section' => $last_content_object['section']['order'],
        'content' => $last_content_object['content']['order']
    ];

http_response_code(200);
die(json_encode(
    ['units' => $json_levels,'last_content'   => $last_content]
    ,JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));

?>