<?php 

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);

$query_get_links = "SELECT 
                    l.label, 
                    l.link,
                    l.id_link,
                    l.ordem
                    FROM links l
                    order by l.ordem
";

$result_get_links = mysqli_query($conn, $query_get_links);

$links = [];

$links['links'] = [];

if( mysqli_num_rows($result_get_links) == 0 ) {

  http_response_code(500);
  die(json_encode([
      'debug' => $sql_contents
  ],JSON_UNESCAPED_UNICODE));

}

while($row = mysqli_fetch_assoc($result_get_links)){
     
  array_push($links['links'], [
    "link"    => $row['link'],
    "label"   => $row['label'],
    "ordem"   => $row['ordem'],
    "linkId"  => $row['id_link']
  ]);

}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);
die(json_encode($links,JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>