<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../config/db-connection.php';
include_once __DIR__ . '/../config/https_environment.php';
include_once __DIR__ . '/../utils/utils.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['search'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'search'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);
$search = mysqli_real_escape_string($conn,$json['search']);

// TEST USER PERMITION
        $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

//EXECUTE SEARCH
    $search_result = array();

    //QUERIES
    $sql_units = "SELECT 
        u.id_unit,
        u.label as unit_label,
        l.id_level,
        l.label as level_label
        FROM units u
        INNER JOIN levels l USING(id_level)
        WHERE u.label LIKE '${search}%';
    ";
    $sql_sections = "SELECT
        s.id_section,
        s.label as section_label,
        u.id_unit,
        u.label as unit_label,
        l.id_level,
        l.label as level_label
        FROM sections s
        INNER JOIN units u USING(id_unit)
        INNER JOIN levels l USING(id_level)
        WHERE s.label LIKE '${search}%';
    ";
    $sql_contents = "SELECT
        c.id_content,
        c.title as content_label,
        s.id_section,
        s.label as section_label,
        u.id_unit,
        u.label as unit_label,
        l.id_level,
        l.label as level_label
        FROM contents c
        INNER JOIN sections s USING(id_section)
        INNER JOIN units u USING(id_unit)
        INNER JOIN levels l USING(id_level)
        WHERE c.meta LIKE '%${search}%';
    ";

    //RESULT
    $result_units = mysqli_query($conn,$sql_units);
    $result_sections = mysqli_query($conn,$sql_sections);
    $result_contents = mysqli_query($conn,$sql_contents);

    if(!$result_units){
        $error = mysqli_error($conn);
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug3' => $sql_units,
            'debug2' => $error,
            'debug' => 'unit'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$result_sections){
        $error = mysqli_error($conn);
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug2' => $error,
            'debug' => 'sections'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$result_contents){
        $error = mysqli_error($conn);
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug2' => $error,
            'debug' => 'contents'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    while($row_sections = mysqli_fetch_assoc($result_sections)){
        $search_result[] = [
            'type' => 'Section',
            'id' => $row_sections['id_section'],
            'label' => $row_sections['section_label'],

            'level' => $row_sections['level_label'],

            'unit' => $row_sections['unit_label'],
            
            
        ];
    }
    while($row_contents = mysqli_fetch_assoc($result_contents)){
        $search_result[] = [
            'type' => 'Content',
            'id' => $row_contents['id_content'],
            'label' => $row_contents['content_label'],

            'level' => $row_contents['level_label'],

            'unit' => $row_contents['unit_label'],

            'section' => $row_contents['section_label']
            
            
        ];
    }

// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode([
        'result' => $search_result
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>