<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(empty($json['id_section'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_section'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);
$id_section = mysqli_real_escape_string($conn,$json['id_section']);
// $id_user = 'a6c90136-f0c8-11ec-a869-00e04c0362fc';
// $id_unit = '07678cc9-f15b-11ec-a0db-00e04c0362fc';

// GET UNIT SECTION DATA
    $sql_sections = "SELECT
        s.`id_section`,
        s.`label`,
        s.`order`,
        s.id_unit,
        s.icon,
        s.unrestricted,
        s.free_access
        FROM sections s
        WHERE `id_section` = '${id_section}';
    ";

    $result_sections = mysqli_query($conn,$sql_sections);

    if(!$result_sections){
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_sections
        ],JSON_UNESCAPED_UNICODE));
    }
    $json_sections = [];

    $row_section = mysqli_fetch_assoc($result_sections);

    $section_id             = $row_section['id_section'];
    $id_unit                = $row_section['id_unit'];
    $section_label          = $row_section['label'];
    $section_order          = $row_section['order'];
    $section_icon           = $row_section['icon'];
    $section_unrestricted   = $row_section['unrestricted'] == 1 ? true: false;
    $section_free_access    = $row_section['free_access'] == 1 ? true: false;

    $new_order_section = array();
// SELECT ALL SECTIONS FROM THIS UNIT
    if($section_order > 0){
        $sql_units = "SELECT id_section, label FROM sections WHERE id_unit = '{$id_unit}' AND `order` > 0 ORDER BY `order` ASC";
        $result_units = mysqli_query($conn,$sql_units);
        if(!$result_units){
            $error = mysqli_error($conn);
            http_response_code(500);
            mysqli_rollback($conn);
            mysqli_close($conn);
            die(json_encode([
                'debug' => $error,
                'debug2' => 'select_units'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    
        $order_units = array();
        $counter = 0;
    
        while($row_units = mysqli_fetch_assoc($result_units)){
            $counter++;
            $new_order_section[] = [
                'id_section' => $row_units['id_section'],
                'label'   => $row_units['label'],
                'order'   => $counter
            ];
        }
    }else{
        $new_order_section[] = [
            'id_section' => $section_id,
            'label'   => $section_label,
            'order'   => $section_order
        ];
    }
// END OPERATION
    $json_sections = [
        'section_data' => [
            "id_section"    =>  $section_id,
            "label"         =>  $section_label,
            "order"         =>  $section_order,
            "icon"          =>  $section_icon,
            "unrestricted"  =>  $section_unrestricted,
            "free_access"   =>  $section_free_access,
            'order_options' =>  $new_order_section
        ]
    ];
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode($json_sections,JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>