<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_section'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_section'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_section = mysqli_real_escape_string($conn,$json['id_section']);

if(empty($json['section_data'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'section_data'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$section_data = $json['section_data'];

if(isset($section_data['label'])){
    $label = mysqli_real_escape_string($conn,$section_data['label']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'label'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


if(isset($section_data['order'])){
    $order = mysqli_real_escape_string($conn,$section_data['order']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'order'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($section_data['icon'])){
    $icon = mysqli_real_escape_string($conn,$section_data['icon']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'icon'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($section_data['unrestricted'])){
    $unrestricted = $section_data['unrestricted'] == 1 ? 1 : 0;
    if($order != 0 && $unrestricted == 1){
        http_response_code(400);
        die(json_encode([
            'message' => 'Apenas sessões "Somente leitura" podem ter acesso irrestrito'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'unrestricted'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($section_data['free_access'])){
    $free_access = $section_data['free_access'] == 1 ? 1 : 0;
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'free_access'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}




// TEST USER PERMITION

        $test_editor_permition = test_editor_permition($conn,$id_user);
    if($test_editor_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_editor_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_editor_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'editor permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

// GET ORDER AND UNIT DATA
    $sql_order = "SELECT s.`order`,
     s.id_unit,
     u.order as unit_order
    FROM sections s
    INNER JOIN units u USING(id_unit) WHERE id_section = '{$id_section}'";

    $result_order = mysqli_query($conn,$sql_order);

    if(!$result_order){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug' => $error
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $row_order = mysqli_fetch_assoc($result_order);
    $old_order = $row_order['order'];
    $unit_order = $row_order['unit_order'];
    $id_unit = $row_order['id_unit'];

    if($old_order != $order){
        // GET USERS FROM THIS UNIT
            $sql_progress = "SELECT up.id_user,
            up.level_order,
            up.unit_order,
            up.section_order,
            up.content_order,
            up.units_progress,
            u.id_unit
            FROM user_progress up
            INNER JOIN levels l ON up.level_order = l.order 
            INNER JOIN units u ON l.id_level = u.id_level 
            WHERE u.id_unit = '{$id_unit}' AND up.id_user NOT IN ('37e44344-f0c5-11ec-a869-00e04c0362fc')
            GROUP by up.id_user";

            $result_progress = mysqli_query($conn,$sql_progress);
            if(!$result_progress){
                $error = mysqli_error($conn);
                http_response_code(500);
                mysqli_rollback($conn);
                mysqli_close($conn);
                die(json_encode([
                    'debug' => $error,
                    'debug2' => 'orders'
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            }

            if(mysqli_num_rows($result_progress) > 0){
                $error = mysqli_error($conn);
                http_response_code(400);
                mysqli_rollback($conn);
                mysqli_close($conn);
                die(json_encode([
                    'message' => 'Não é possível alterar a ordenação de uma Section enquanto houverem alunos cursando a Unit em que ela pertence.'
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            }

            $sql_update_section = "UPDATE sections SET `order` = {$order} WHERE id_section = '{$id_section}'";
            if($old_order > $order){
                $sql_update_sections = "UPDATE sections SET `order` = `order` + 1 WHERE id_unit = '{$id_unit}' AND `order` < {$old_order} AND id_section NOT IN ('{$id_section}')";
            }else{
                $sql_update_sections = "UPDATE sections SET `order` = `order` - 1 WHERE id_unit = '{$id_unit}' AND `order` > {$old_order} AND `order` <= {$order} AND id_section NOT IN ('{$id_section}')";
            }

            $result_update_section = mysqli_query($conn,$sql_update_section);
            $result_update_sections = mysqli_query($conn,$sql_update_sections);


            // UNIT STEP FORWARD
            foreach($relocate_unit_users as $id_student){
                $user_progress = $all_users[$id_student];
                $unit_progress = $user_progress['units_progress'];

                $unit_progress = json_encode($unit_progress, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
                //NEXT CONTENT 
                    $sql_next_unit = "SELECT
                        u.order as order_unit
                        FROM units u 
                        INNER JOIN levels l USING(id_level)
                        WHERE u.`order` > {$user_progress['unit_order']} AND
                        l.id_level = '{$id_level}' AND

                        u.`status` = 1 AND
                        l.`status` = 1
                    ORDER BY u.`order` ASC
                    LIMIT 1";

                    $result_next_unit = mysqli_query($conn,$sql_next_unit);
                    
                    if(!$result_next_unit){
                        $error = mysqli_error($conn);
                        mysqli_rollback($conn);
                        mysqli_close($conn);
                        http_response_code(500);
                        die(json_encode([
                            'debug' => $error,
                            'debug2' => $sql_next_unit
                        ], JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE));
                    }

                    if(mysqli_num_rows($result_next_unit) < 1){
                        //SELECT NEXT LEVEL UNIT
                            $res_next_level = get_closest_content_by_next_level($conn,$user_progress['level_order']);
                            
                            if($res_next_level['status'] != 200){
                                http_response_code($res_next_level['status']);
                                mysqli_rollback($conn);
                                mysqli_close($conn);
                                die(json_encode([
                                    'debug' => $res_next_level['debug'],
                                    'debug2' => 'next level progress'
                                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
                            }

                            $res_next_level = $res_next_level['response'];

                            $user_progress['level_order'] = $res_next_level['level']['order'];
                            $user_progress['unit_order'] = $res_next_level['unit']['order'];
                            $user_progress['section_order'] = $res_next_level['section']['order'];
                            $user_progress['content_order'] = $res_next_level['content']['order'];
                        // END SELECT
                    }else{
                        $row_next_unit = mysqli_fetch_assoc($result_next_unit);
                        $user_progress['unit_order'] = $row_next_unit['order_unit'];
                    }

                //EXEC UPDATE
                $sql_update_progress = "CALL sp_update_progress(
                    '{$id_user}',
                    '{$id_student}',
                    '{$user_progress['level_order']}',
                    '{$user_progress['unit_order']}',
                    '{$user_progress['section_order']}',
                    '{$user_progress['content_order']}',
                    '{$unit_progress}'
                )";

                $result_update_progress = mysqli_query($conn,$sql_update_progress);

                if(!$result_update_progress){
                    $error = mysqli_error($conn);
                    mysqli_rollback($conn);
                    mysqli_close($conn);
                    http_response_code(500);
                    die(json_encode([
                        'debug' => $error,
                        'debug2' => $sql_update_progress,
                        'debug3' => 'step'
                    ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
                }

                mysqli_next_result($conn);
            }

            // RESET PROGRESS TO FIRST CONTENT
            foreach($reset_unit_users as $id_student){
                
                // GET USER PROGRESS PERMITION
                    $user_progress = fetch_user_progress($id_student,$conn);
                //END GET
                
                //EMPTY UNIT PROGRESS
                    $unit_progress = $user_progress['unitProgress'];

                    if($unit_progress != 'null' && $unit_progress != null){
                        $json_progress = json_decode($unit_progress,true);
                        unset($json_progress[$user_progress['id_unit']]);
                        $unit_progress = json_encode($json_progress, JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES);
                    }

                    $debug[$id_student] = [
                        'before reset' => $user_progress
                    ];
                //END
                //GET FIRST SECTION/CONTENT FROM THIS UNIT
                    $new_progress = get_first_content_id_by_unit($conn,[
                        'unit' => [ 'order' => $user_progress['progress']['unit'] ],
                        'level' => [ 'order' => $user_progress['progress']['level']]
                    ]);
                
                    if($new_progress['status']!= 200){
                        mysqli_rollback($conn);
                        mysqli_close($conn);
                        http_response_code(500);
                        die(json_encode([
                            'debug' => 'new progress'
                        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
                    }

                    $user_progress['level_order']     = $new_progress['response']['level']['order'];
                    $user_progress['unit_order']      = $new_progress['response']['unit']['order'];
                    $user_progress['section_order']   = $new_progress['response']['section']['order'];
                    $user_progress['content_order']   = $new_progress['response']['content']['order'];

                    $debug[$id_student]['after reset'] = $user_progress;
                    $debug[$id_student]['new progress'] = $new_progress;
                    $debug[$id_student]['id unit'] = $user_progress['id_unit'];
                //EXEC UPDATE
                $sql_update_progress = "CALL sp_update_progress(
                    '{$id_user}',
                    '{$id_student}',
                    '{$user_progress['level_order']}',
                    '{$user_progress['unit_order']}',
                    '{$user_progress['section_order']}',
                    '{$user_progress['content_order']}',
                    '{$unit_progress}'
                )";

                $result_update_progress = mysqli_query($conn,$sql_update_progress);

                if(!$result_update_progress){
                    $error = mysqli_error($conn);
                    mysqli_rollback($conn);
                    mysqli_close($conn);
                    http_response_code(500);
                    die(json_encode([
                        'debug' => $error,
                        'debug2' => $sql_update_progress,
                        'debug3' => 'reset'
                    ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
                }

                mysqli_next_result($conn);
            }

            // UPDATE USERS THAT MUST RESET THE UNIT PROGRESS.
            foreach($clean_older_progress as $id_student){

                //CLEAN PROGRESS IN THIS UNIT
                delete_user_answers_by_section_id($conn,$id_student,$id_section);

            }

    }

// SUBMIT UPDATE

$sql_create = "CALL sp_update_section_test('{$id_section}','{$id_user}','{$label}','{$icon}',{$order},1,{$free_access},{$unrestricted})";

$result_create = mysqli_query($conn,$sql_create);

if(!$result_create){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug_sql' => $sql_create
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

