<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../../../config/db-connection.php';
include_once __DIR__ . '/../../../config/https_environment.php';
include_once __DIR__ . '/../../../utils/utils.php';

$json = file_get_contents('php://input');
$json = json_decode($json,true);

if(empty($json['id_user'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_code'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_code'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_code = mysqli_real_escape_string($conn,$json['id_code']);

// TEST USER PERMITION
    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
// GET CODE DATA
    $sql_code = "SELECT
    label FROM codes WHERE id_code = '{$id_code}';";

    $result_code = mysqli_query($conn,$sql_code);

    if(!$result_code){
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_code
        ],JSON_UNESCAPED_UNICODE));
    }
    $code_data = array();

    while($row_code = mysqli_fetch_assoc($result_code)){
        $code_data = [
            'label' => $row_code['label']
        ]; 
    }
// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode([
        "code_data" => $code_data
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>