<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../../config/db-connection.php';
include_once __DIR__ . '/../../../config/https_environment.php';
include_once __DIR__ . '/../../../utils/utils.php';

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);

if(empty($json['id_user'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);


if(empty($json['id_code'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_code'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_code = mysqli_real_escape_string($conn,$json['id_code']);

// TEST USER PERMITION
    $test_permition = test_permition($conn,$id_user,3);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
//

//check if it can be deleted
$sql_check = "SELECT id_user FROM users WHERE id_code = '{$id_code}';";

$result_check = mysqli_query($conn,$sql_check);

if(!$result_check){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(mysqli_num_rows($result_check) > 0){
    http_response_code(400);
    die(json_encode([
        'message' => 'Você não pode deletar um código em uso'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$sql_delete = "DELETE FROM codes 
        WHERE id_code = '{$id_code}';";

$result_delete = mysqli_query($conn,$sql_delete);

if(!$result_delete){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

