<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../../../config/db-connection.php';
include_once __DIR__ . '/../../../config/https_environment.php';
include_once __DIR__ . '/../../../utils/utils.php';

$json = file_get_contents('php://input');
$json = json_decode($json,true);

if(empty($json['id_user'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$id_user = mysqli_real_escape_string($conn,$json['id_user']);

// TEST USER PERMITION
    $test_permition = test_permition($conn,$id_user,3);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
// GET CODES DATA
    $code_list = array();
    $sql_codes = "SELECT
    id_code,
    label
    FROM codes";
    
    $result_codes = mysqli_query($conn,$sql_codes);

    if(!$result_codes){
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_codes
        ],JSON_UNESCAPED_UNICODE));
    }

    while($row_code = mysqli_fetch_assoc($result_codes)){

        $code_list[] = [
            'id' => $row_code['id_code'],
            'label' => $row_code['label']
        ];

    }
// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode([
        "response" => [
            "codes" => $code_list
        ]
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>