<?php

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header('Content-Type: application/json; charset=utf-8');

include_once __DIR__ . '/../../../config/db-connection.php';
include_once __DIR__ . '/../../../config/https_environment.php';
include_once __DIR__ . '/../../../utils/utils.php';

$json = file_get_contents('php://input');
$json = json_decode($json,true);

if(empty($json['id_user'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_user'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_user = mysqli_real_escape_string($conn,$json['id_user']);

if(empty($json['id_email_template'])){
    mysqli_close($conn);
    http_response_code(400);
    die(json_encode([
        'debug' => 'id_email_template'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$id_email_template = mysqli_real_escape_string($conn,$json['id_email_template']);

// TEST USER PERMITION
    $test_permition = test_permition($conn,$id_user,1);
    if($test_permition['status'] != 200){
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $test_permition
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    if(!$test_permition['response']['permition']){
        mysqli_close($conn);
        http_response_code(403);
        die(json_encode([
            'debug' => 'permition'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    
// GET EMAIL DATA
    $sql_email = "SELECT
    content,label,`subject`, params FROM email_templates WHERE id_email_template = '{$id_email_template}';";

    $result_email = mysqli_query($conn,$sql_email);

    if(!$result_email){
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_email
        ],JSON_UNESCAPED_UNICODE));
    }
    $email_data = array();

    while($row_email = mysqli_fetch_assoc($result_email)){
        $email_data = [
            'content' => $row_email['content'],
            'label'   => $row_email['label'],
            'subject'   => $row_email['subject'],
            'params'    => json_decode($row_email['params'],true)
        ]; 
    }

// END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode([
        "email_data" => $email_data
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

?>