<?php
    header("Access-Control-Allow-Origin: *");
    header("Access-Control-Allow-Headers: *");

    include_once __DIR__ . '/../../../config/db-connection.php';
    include_once __DIR__ . '/../../../config/https_environment.php';
    include_once __DIR__ . '/../../../utils/utils.php';

    $json = file_get_contents('php://input');
    
    $json = json_decode($json,true);

    if(empty($json['id_user'])){
        http_response_code(400);
        mysqli_close($conn);
        die(json_encode([
            'debug' => 'id_user'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $id_user = mysqli_real_escape_string($conn,$json['id_user']);

    if(empty($json['id_student'])){
        http_response_code(400);
        mysqli_close($conn);
        die(json_encode([
            'debug' => 'id_student'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $id_student = mysqli_real_escape_string($conn,$json['id_student']);

//GET STUDENT PROGRESS
    $result_user_progress = get_user_progress($id_student,$url);

    if($result_user_progress['status'] != 200){
        http_response_code($result_user_progress['status']);
        die(json_encode([
            'debug' => $result_user_progress['debug']
        ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
    }

    $user_progress_json = $result_user_progress['response']['user_progress'];
    $user_unit_progress = json_decode($user_progress_json['unitProgress'],true);
    $user_progress = $user_progress_json['progress'];

//VERIFY PERMITIONS
    $get_order = true;
    $next_unit_id = null;
    if($id_user != $id_student){
        if(empty($json['id_unit'])){
            http_response_code(400);
            mysqli_close($conn);
            die(json_encode([
                'debug' => 'id_unit'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
        $id_unit = mysqli_real_escape_string($conn,$json['id_unit']);

        // TEST USER PERMITION
        $test_permition = test_permition($conn,$id_user,2);
        if($test_permition['status'] != 200){
            mysqli_close($conn);
            http_response_code(500);
            die(json_encode([
                'debug' => $test_permition
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
        if(!$test_permition['response']['permition']){
            mysqli_close($conn);
            http_response_code(403);
            die(json_encode([
                'debug' => 'permition'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    }else{
        // SQL GET ID'S FROM CURRENT CONTENT
            $sql_id = "SELECT 
                c.`id_content`,
                c.`id_section`,
                l.id_level,
                u.id_unit
                FROM contents c
                INNER JOIN sections s ON c.id_section = s.id_section
                INNER JOIN units u ON u.id_unit = s.id_unit
                INNER JOIN `levels` l ON u.id_level = l.id_level
                WHERE 
                    c.order = '{$user_progress['content']}' AND
                    s.order = '{$user_progress['section']}' AND
                    u.order = '{$user_progress['unit']}' AND
                    l.order = '{$user_progress['level']}' AND
                c.status = 1
            ";
            
            $result_id = mysqli_query($conn,$sql_id);
            
            if(!$result_id){
                $error = mysqli_error($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => $error
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            }
            
            $row_id = mysqli_fetch_assoc($result_id);

            $id_content = $row_id['id_content'];
            $id_section = $row_id['id_section'];
            $id_unit    = $row_id['id_unit'];
            $id_level   = $row_id['id_level'];

            $content_order  = $user_progress['content'];
            $section_order  = $user_progress['section'];
            $unit_order     = $user_progress['unit'];
            $level_order    = $user_progress['level'];

        // GET NEXT CONTENT ORDER
            $next_content_data = get_next_content_id($conn,[
                'content' => [ 'id' => $id_content, 'order' => $content_order ],
                'section' => [ 'id' => $id_section, 'order' => $section_order ],
                'unit'    => [ 'id' => $id_unit, 'order' => $unit_order ],
                'level'   => [ 'id' => $id_level, 'order' => $level_order ]
            ]);

            if($next_content_data['status'] != 200){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code($next_content_data['status']);
                die(json_encode([
                    'debug' => $next_content_data['debug']
                ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
            }

            $response_next_content =    $next_content_data['response'];
            $att_key =                  $response_next_content['att_key'];

        // VERIFY IF THERE IS A NEXT CONTENT AVALIABLE
            if($att_key != 'end'){
                $next_level_order =         isset($response_next_content['level']) ?      intval($response_next_content['level']['order']) : 0;
                $next_unit_order =          isset($response_next_content['unit']) ?       intval($response_next_content['unit']['order']) : 0;
                $next_section_order =       isset($response_next_content['section']) ?    intval($response_next_content['section']['order']) : 0;
                $next_content_order =       isset($response_next_content['content']) ?    intval($response_next_content['content']['order']) : 0;
                // VERIFY IF NEXT CONTENT IS HIGHER THAN ACTUAL USER PROGRESS
                    if($next_level_order > intval($user_progress['level'])){
                        $user_progress['level']     = $next_level_order;
                        $user_progress['unit']      = $next_unit_order;
                        $user_progress['section']   = $next_section_order;
                        $user_progress['content']   = $next_content_order;
                    }else if($next_level_order == intval($user_progress['level']) && $next_unit_order > intval($user_progress['unit'])){
                        $user_progress['unit'] = $next_unit_order;
                        $user_progress['section'] = $next_section_order;
                        $user_progress['content'] = $next_content_order;
                    }else{
                        mysqli_rollback($conn);
                        mysqli_close($conn);
                        http_response_code(400);
                        die(json_encode([
                            'debug' => 'nothing to do'
                        ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
                    }
                    // SET NEW PROGRESS
                        $get_order = false;
                        $next_unit_id = $response_next_content['unit']['id'];
            }else{
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(200);
                die();
            }
    }
//CHECK IF YOU NEED TO FETCH THE PROGRESS ORDER 
    if($get_order == true){
        //GET UNIT ORDER PERMITION
            $sql_order = "SELECT 
            l.order as level_order, 
            u.order as unit_order,
            l.id_level,
            u.id_unit
            FROM units u
            INNER JOIN levels l USING(id_level)
            WHERE u.id_unit = '{$id_unit}'";
        
            $result_order = mysqli_query($conn,$sql_order);
            if(!$result_order){
                $error = mysqli_error($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => $error
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            }
            $row_order = mysqli_fetch_assoc($result_order);
        
            $level_order = $row_order['level_order'];
            $unit_order = $row_order['unit_order'];
        
            $id_level = $row_order['id_level'];
            $id_unit = $row_order['id_unit'];
        
        //GET FIRST SECTION/CONTENT FROM THIS UNIT
            $new_progress = get_first_content_id_by_unit($conn,[
                'unit' => [ 'id' => $id_unit, 'order' => $unit_order ],
                'level' => [ 'id' => $id_level, 'order' => $level_order ]
            ]);

            if($new_progress == null){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(400);
                die(json_encode([
                    'message' => 'Não foi possível definir o progresso do aluno. Verifique se a Unit em questão possui conteúdos de avaliação ativos (Exercices).'
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            }

            if($new_progress['status']!= 200){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => 'new progress'
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            }

            $user_progress['level']     = $new_progress['response']['level']['order'];
            $user_progress['unit']      = $new_progress['response']['unit']['order'];
            $user_progress['section']   = $new_progress['response']['section']['order'];
            $user_progress['content']   = $new_progress['response']['content']['order'];
        
    }
//UPDATE PROGRESS
    $json_unit_progress = json_encode($user_unit_progress,true);

    // SUBMIT UPDATE
    $sql_update_progress = "CALL sp_update_progress(
        '{$id_user}',
        '{$id_student}',
        '{$user_progress['level']}',
        '{$user_progress['unit']}',
        '{$user_progress['section']}',
        '{$user_progress['content']}',
        '{$json_unit_progress}'
    )";

    $result_update_progress = mysqli_query($conn,$sql_update_progress);

    if(!$result_update_progress){
        mysqli_rollback($conn);
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $sql_update_progress
        ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
    }
    mysqli_next_result($conn);

//END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die(json_encode([
        'next_unit_id' => $next_unit_id,
        'user_progress' => $user_progress
    ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
?>
