<?php
    header("Access-Control-Allow-Origin: *");
    header("Access-Control-Allow-Headers: *");

    include_once __DIR__ . '/../../../config/db-connection.php';
    include_once __DIR__ . '/../../../config/https_environment.php';
    include_once __DIR__ . '/../../../utils/utils.php';

    $json = file_get_contents('php://input');
    
    $json = json_decode($json,true);

    if(empty($json['id_user'])){
        http_response_code(400);
        mysqli_close($conn);
        die(json_encode([
            'debug' => 'id_user'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $id_user = mysqli_real_escape_string($conn,$json['id_user']);

    if(empty($json['id_student'])){
        http_response_code(400);
        mysqli_close($conn);
        die(json_encode([
            'debug' => 'id_student'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $id_student = mysqli_real_escape_string($conn,$json['id_student']);


    if(empty($json['id_unit'])){
        http_response_code(400);
        mysqli_close($conn);
        die(json_encode([
            'debug' => 'id_unit'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $id_unit = mysqli_real_escape_string($conn,$json['id_unit']);


    $recursive = $json['recursive'] ? true : false;

//VERIFY PERMITIONS
    $send_email = false;
    if($id_user != $id_student){
        // TEST USER PERMITION
        $test_permition = test_permition($conn,$id_user,3);
        if($test_permition['status'] != 200){
            mysqli_close($conn);
            http_response_code(500);
            die(json_encode([
                'debug' => $test_permition
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
        if(!$test_permition['response']['permition']){
            mysqli_close($conn);
            http_response_code(403);
            die(json_encode([
                'debug' => 'permition'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }
    }else{
        $send_email = true;
    }
//GET STUDENT PROGRESS
    $result_user_progress = get_user_progress($id_student,$url);

    if($result_user_progress['status'] != 200){
        http_response_code($result_user_progress['status']);
        die(json_encode([
            'debug' => $result_user_progress['debug']
        ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
    }

    $user_progress_json = $result_user_progress['response']['user_progress'];
    $user_unit_progress = json_decode($user_progress_json['unitProgress'],true);
    $user_progress = $user_progress_json['progress'];
//GET UNIT ORDER PERMITION
    $sql_order = "SELECT 
    l.order as level_order, 
    u.order as unit_order,
    l.id_level,
    u.id_unit
    FROM units u
    INNER JOIN levels l USING(id_level)
    WHERE u.id_unit = '{$id_unit}'";

    $result_order = mysqli_query($conn,$sql_order);
    if(!$result_order){
        $error = mysqli_error($conn);
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $error
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    $row_order = mysqli_fetch_assoc($result_order);

    $level_order = $row_order['level_order'];
    $unit_order = $row_order['unit_order'];

    $id_level = $row_order['id_level'];
    $id_unit = $row_order['id_unit'];
//DELETE PROGRESS
    mysqli_begin_transaction($conn);

    $sql_delete_answers = "DELETE FROM answers
    WHERE id_user = '{$id_student}' AND
    id_content IN (
            SELECT id_content
            FROM contents c
            INNER JOIN sections s USING(id_section)
            INNER JOIN units u USING(id_unit)
            INNER JOIN levels l USING(id_level)
            WHERE l.id_level = '{$id_level}' AND
            u.id_unit = '{$id_unit}'
        )
    ";
    if(!mysqli_query($conn,$sql_delete_answers)){
        $error = mysqli_error($conn);
        mysqli_rollback($conn);
        mysqli_close($conn);
        http_response_code(500);
        die(json_encode([
            'debug' => $error
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));

    }

//CHECK IF PROGRESS HAS TO BE CHANGED
    if(
        $level_order == $user_progress['level'] &&
        $unit_order == $user_progress['unit']
    ){


        //GET FIRST SECTION/CONTENT FROM THIS UNIT
        $new_progress = get_first_content_id_by_unit($conn,[
            'unit' => [ 'id' => $id_unit, 'order' => $unit_order ],
            'level' => [ 'id' => $id_level, 'order' => $level_order ]
        ]);

        if($new_progress['status']!= 200){
            mysqli_rollback($conn);
            mysqli_close($conn);
            http_response_code(500);
            die(json_encode([
                'debug' => 'new progress'
            ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        }

        $user_progress['section'] = $new_progress['response']['section']['order'];
        $user_progress['content'] = $new_progress['response']['content']['order'];

        unset($user_unit_progress[$id_unit]);
        $json_unit_progress = json_encode($user_unit_progress,true);

        // SUBMIT UPDATE
        $sql_update_progress = "CALL sp_update_progress(
            '{$id_user}',
            '{$id_student}',
            '{$user_progress['level']}',
            '{$user_progress['unit']}',
            '{$user_progress['section']}',
            '{$user_progress['content']}',
            '{$json_unit_progress}'
        )";

        $result_update_progress = mysqli_query($conn,$sql_update_progress);

        if(!$result_update_progress){
            mysqli_rollback($conn);
            mysqli_close($conn);
            http_response_code(500);
            die(json_encode([
                'debug' => $sql_update_progress
            ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
        }
        mysqli_next_result($conn);

        //
    }else{
        unset($user_unit_progress[$id_unit]);

        if($recursive){

            //GET FIRST SECTION/CONTENT FROM THIS UNIT
            $new_progress = get_first_content_id_by_unit($conn,[
                'unit' => [ 'id' => $id_unit, 'order' => $unit_order ],
                'level' => [ 'id' => $id_level, 'order' => $level_order ]
            ]);

            if($new_progress['status']!= 200){
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => 'new progress'
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
            }

            $user_progress['level']     = $new_progress['response']['level']['order'];
            $user_progress['unit']      = $new_progress['response']['unit']['order'];
            $user_progress['section']   = $new_progress['response']['section']['order'];
            $user_progress['content']   = $new_progress['response']['content']['order'];

            $sql_units = "SELECT u.id_unit
                        FROM contents c
                        INNER JOIN sections s USING(id_section)
                        INNER JOIN units u USING(id_unit)
                        INNER JOIN levels l USING(id_level)
                        WHERE 
                            ( l.order > '{$level_order}') OR
                            ( l.id_level = '{$id_level}' AND u.order > '{$unit_order}' )";

            $result_units = mysqli_query($conn,$sql_units);

            if(!$result_units){
                $error = mysqli_error($conn);
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => $error
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        
            }

            while($row_units = mysqli_fetch_assoc($result_units)){
                unset($user_unit_progress[$row_units['id_unit']]);
            }

            //DELETE ANSWERS RECURSIVELY
            $sql_delete_answers = "DELETE FROM answers
            WHERE id_user = '{$id_student}' AND
            id_content IN (
                    SELECT id_content
                    FROM contents c
                    INNER JOIN sections s USING(id_section)
                    INNER JOIN units u USING(id_unit)
                    INNER JOIN levels l USING(id_level)
                    WHERE 
                        ( l.order > '{$level_order}') OR
                        ( l.id_level = '{$id_level}' AND u.order > '{$unit_order}' )
                )
            ";

            if(!mysqli_query($conn,$sql_delete_answers)){
                $error = mysqli_error($conn);
                mysqli_rollback($conn);
                mysqli_close($conn);
                http_response_code(500);
                die(json_encode([
                    'debug' => $error
                ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        
            }

        }

        $json_unit_progress = json_encode($user_unit_progress,true);

        // SUBMIT UPDATE
        $sql_update_progress = "CALL sp_update_progress(
            '{$id_user}',
            '{$id_student}',
            '{$user_progress['level']}',
            '{$user_progress['unit']}',
            '{$user_progress['section']}',
            '{$user_progress['content']}',
            '{$json_unit_progress}'
        )";

        $result_update_progress = mysqli_query($conn,$sql_update_progress);

        if(!$result_update_progress){
            mysqli_rollback($conn);
            mysqli_close($conn);
            http_response_code(500);
            die(json_encode([
                'debug' => $sql_update_progress
            ], JSON_UNESCAPED_UNICODE, JSON_UNESCAPED_SLASHES));
        }
        mysqli_next_result($conn);
    }

    if($send_email == true){
        send_reset_unit_email($conn,$id_student,$id_unit,$url_alt);
    }

//END OPERATION
    http_response_code(200);
    mysqli_commit($conn);
    mysqli_close($conn);
    die();
?>
